class PlatformUserDetail {
  int? id;
  int? userId;
  String? firstName;
  String? lastName;
  String? displayName;
  String? email;
  String? thumbnail;
  String? phone;
  String? firebaseId;
  String? username;
  int? createAt;
  int? deleteAt;
  int? banAt;
  int? totalPoints;
  List<PlatformUserDetailLevel>? levels;

  PlatformUserDetail({
    this.id,
    this.userId,
    this.firstName,
    this.lastName,
    this.displayName,
    this.email,
    this.thumbnail,
    this.phone,
    this.firebaseId,
    this.username,
    this.createAt,
    this.deleteAt,
    this.banAt,
    this.levels,
    this.totalPoints,
  });

  PlatformUserDetail.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    userId = json["userId"];
    firstName = json["firstName"];
    lastName = json["lastName"];
    displayName = json["displayName"];
    if (json["email"] is String) {
      email = json["email"];
    }
    if (json["thumbnail"] is String) {
      thumbnail = json["thumbnail"];
    }
    if (json["phone"] is String) {
      phone = json["phone"];
    }
    if (json["username"] is String) {
      username = json["username"];
    }
    firebaseId = json["firebaseId"];
    if (json["createAt"] is int) {
      createAt = json["createAt"];
    }
    if (json["deleteAt"] is int) {
      deleteAt = json["deleteAt"];
    }
    if (json["banAt"] is int) {
      banAt = json["banAt"];
    }
    if (json["totalPoints"] is int) {
      totalPoints = json["totalPoints"];
    }
    if (json["levels"] is List) {
      levels = json["levels"] == null
          ? null
          : (json["levels"] as List)
              .map((e) => PlatformUserDetailLevel.fromJson(e))
              .toList();
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["firstName"] = firstName;
    _data["lastName"] = lastName;
    _data["displayName"] = displayName;
    _data["email"] = email;
    _data["thumbnail"] = thumbnail;
    _data["phone"] = phone;
    _data["username"] = username;
    _data["firebaseId"] = firebaseId;
    _data["createAt"] = createAt;
    _data["deleteAt"] = deleteAt;
    _data["banAt"] = banAt;
    _data["totalPoints"] = totalPoints;
    if (levels != null) {
      _data["levels"] = levels?.map((e) => e.toJson()).toList();
    }
    return _data;
  }
}

class PlatformUserDetailLevel {
  int? id;
  String? label;
  String? label2;
  String? colorCode;
  int? numberOfPointsRequired;
  String? badgePictureUrl;
  int? platformId;
  int? levelProgressPercentage;
  int? order;
  int? isCurrentLevel;

  PlatformUserDetailLevel(
      {this.id,
      this.label,
      this.label2,
      this.colorCode,
      this.numberOfPointsRequired,
      this.badgePictureUrl,
      this.platformId,
      this.levelProgressPercentage,
      this.order,
      this.isCurrentLevel});

  PlatformUserDetailLevel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) {
      id = json["id"];
    }
    if (json["label"] is String) {
      label = json["label"];
    }
    if (json["label2"] is String) {
      label2 = json["label2"];
    }
    if (json["colorCode"] is String) {
      colorCode = json["colorCode"];
    }
    if (json["numberOfPointsRequired"] is int) {
      numberOfPointsRequired = json["numberOfPointsRequired"];
    }
    if (json["badgePictureUrl"] is String) {
      badgePictureUrl = json["badgePictureUrl"];
    }
    if (json["platformId"] is int) {
      platformId = json["platformId"];
    }
    if (json["levelProgressPercentage"] is int) {
      levelProgressPercentage = json["levelProgressPercentage"];
    }
    if (json["order"] is int) {
      order = json["order"];
    }
    if (json["isCurrentLevel"] is int) {
      isCurrentLevel = json["isCurrentLevel"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["label"] = label;
    _data["label2"] = label2;
    _data["colorCode"] = colorCode;
    _data["numberOfPointsRequired"] = numberOfPointsRequired;
    _data["badgePictureUrl"] = badgePictureUrl;
    _data["platformId"] = platformId;
    _data["levelProgressPercentage"] = levelProgressPercentage;
    _data["order"] = order;
    _data["isCurrentLevel"] = isCurrentLevel;
    return _data;
  }
}
