class CurrencyAvailable {
  String? symbol;
  String? thousandSeparator;
  String? decimalSeparator;
  int? decimalPlaces;
  int? symbolPosition;
  String? symbolForBillion;
  String? symbolForMillion;
  String? symbolForThousands;
  int? subUnit;
  String? currencyName;
  String? currencyCode;

  CurrencyAvailable(
      {this.symbol,
      this.thousandSeparator,
      this.decimalSeparator,
      this.decimalPlaces,
      this.symbolPosition,
      this.symbolForBillion,
      this.symbolForMillion,
      this.symbolForThousands,
      this.subUnit,
      this.currencyName,
      this.currencyCode});

  CurrencyAvailable.fromJson(Map<String, dynamic> json) {
    symbol = json["symbol"];
    thousandSeparator = json["thousandSeparator"];
    decimalSeparator = json["decimalSeparator"];
    decimalPlaces = json["decimalPlaces"];
    symbolPosition = json["symbolPosition"];
    symbolForBillion = json["symbolForBillion"];
    symbolForMillion = json["symbolForMillion"];
    symbolForThousands = json["symbolForThousands"];
    subUnit = json["subUnit"];
    currencyName = json["currencyName"];
    currencyCode = json["currencyCode"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["symbol"] = symbol;
    _data["thousandSeparator"] = thousandSeparator;
    _data["decimalSeparator"] = decimalSeparator;
    _data["decimalPlaces"] = decimalPlaces;
    _data["symbolPosition"] = symbolPosition;
    _data["symbolForBillion"] = symbolForBillion;
    _data["symbolForMillion"] = symbolForMillion;
    _data["symbolForThousands"] = symbolForThousands;
    _data["subUnit"] = subUnit;
    _data["currencyName"] = currencyName;
    _data["currencyCode"] = currencyCode;
    return _data;
  }

  CurrencyAvailable copyWith({
    String? symbol,
    String? thousandSeparator,
    String? decimalSeparator,
    int? decimalPlaces,
    int? symbolPosition,
    String? symbolForBillion,
    String? symbolForMillion,
    String? symbolForThousands,
    int? subUnit,
    String? currencyName,
    String? currencyCode,
  }) =>
      CurrencyAvailable(
        symbol: symbol ?? this.symbol,
        thousandSeparator: thousandSeparator ?? this.thousandSeparator,
        decimalSeparator: decimalSeparator ?? this.decimalSeparator,
        decimalPlaces: decimalPlaces ?? this.decimalPlaces,
        symbolPosition: symbolPosition ?? this.symbolPosition,
        symbolForBillion: symbolForBillion ?? this.symbolForBillion,
        symbolForMillion: symbolForMillion ?? this.symbolForMillion,
        symbolForThousands: symbolForThousands ?? this.symbolForThousands,
        subUnit: subUnit ?? this.subUnit,
        currencyName: currencyName ?? this.currencyName,
        currencyCode: currencyCode ?? this.currencyCode,
      );
}
