import 'package:_private_core/_private_core.dart';
import 'package:_private_core_network/network_resources/resources.dart';

import 'app_api.dart';
import 'models/language_available.dart';

class LanguageRepo {
  LanguageRepo._();

  static LanguageRepo? _instance;

  factory LanguageRepo([MyAppApi? api]) {
    _instance ??= LanguageRepo._();
    _instance!._api = api ?? MyAppApiImp();
    return _instance!;
  }

  late MyAppApi _api;

  get api => _api;

  Map<String, dynamic> _mapParms([Map<String, dynamic>? value]) {
    Map<String, dynamic> params = {
      'platformId': valuePlatformByConfig(),
      'languageCode': appPrefs.languageCode,
    };
    if (value != null && value.isNotEmpty) params.addAll(value);
    params.removeWhere((key, value) => value == null);
    return params;
  }

  //keywords : homelidoApply, homelidoSearch, arckipelWebsite, arckipelShop
  Future<List<LanguageAvailable>> getLanguageAvailableByKeyword(
      [params]) async {
    NetworkResponse response =
        await _api.getLanguageAvailableByKeyword(_mapParms(params));
    return response.data ?? [];
  }

  Future<List<LanguageAvailable>> getLanguagesOfCountry(params) async {
    NetworkResponse response =
        await _api.getLanguagesOfCountry(_mapParms(params));
    return response.data ?? [];
  }
}
