class PaymentPayorderResult {
  String? stripeId;
  String? stripeClientSecret;
  String? stripeStatus;
  dynamic? price;
  String? currency;
  dynamic? subUnit;

  PaymentPayorderResult(
      {this.stripeId,
      this.stripeClientSecret,
      this.stripeStatus,
      this.price,
      this.currency,
      this.subUnit});

  PaymentPayorderResult.fromJson(Map<String, dynamic> json) {
    stripeId = json["stripeId"];
    stripeClientSecret = json["stripeClientSecret"];
    stripeStatus = json["stripeStatus"];
    price = json["price"];
    currency = json["currency"];
    subUnit = json["subUnit"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["stripeId"] = stripeId;
    _data["stripeClientSecret"] = stripeClientSecret;
    _data["stripeStatus"] = stripeStatus;
    _data["price"] = price;
    _data["currency"] = currency;
    _data["subUnit"] = subUnit;
    return _data;
  }

  PaymentPayorderResult copyWith({
    String? stripeId,
    String? stripeClientSecret,
    String? stripeStatus,
    double? price,
    String? currency,
    double? subUnit,
  }) =>
      PaymentPayorderResult(
        stripeId: stripeId ?? this.stripeId,
        stripeClientSecret: stripeClientSecret ?? this.stripeClientSecret,
        stripeStatus: stripeStatus ?? this.stripeStatus,
        price: price ?? this.price,
        currency: currency ?? this.currency,
        subUnit: subUnit ?? this.subUnit,
      );
}
