class TheMovieKeyword {
  int? id;
  String? name;

  TheMovieKeyword({this.id, this.name});

  TheMovieKeyword.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    name = json["name"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["name"] = name;
    return _data;
  }

  TheMovieKeyword copyWith({
    int? id,
    String? name,
  }) =>
      TheMovieKeyword(
        id: id ?? this.id,
        name: name ?? this.name,
      );
}

class TheMovieLanguage {
  String? iso6391;
  String? englishName;
  String? name;

  TheMovieLanguage({this.iso6391, this.englishName, this.name});

  TheMovieLanguage.fromJson(Map<String, dynamic> json) {
    iso6391 = json["iso_639_1"];
    englishName = json["english_name"];
    name = json["name"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["iso_639_1"] = iso6391;
    _data["english_name"] = englishName;
    _data["name"] = name;
    return _data;
  }

  TheMovieLanguage copyWith({
    String? iso6391,
    String? englishName,
    String? name,
  }) =>
      TheMovieLanguage(
        iso6391: iso6391 ?? this.iso6391,
        englishName: englishName ?? this.englishName,
        name: name ?? this.name,
      );
}
