class TokenResponseLogin {
  String? accessToken;
  String? refreshToken;
  int? alreadyLoginBefore;
  String? firstName;
  String? lastName;
  String? firebaseId;
  int? registrationLevel;
  int? registrationLevelRequired;
  int? waitForApproval;
  String? qrCode;
  TokenResponseLoginMqtt? mqtt;
  int? isPro;

  TokenResponseLogin({
    this.accessToken,
    this.refreshToken,
    this.alreadyLoginBefore,
    this.firstName,
    this.lastName,
    this.firebaseId,
    this.registrationLevel,
    this.registrationLevelRequired,
    this.waitForApproval,
    this.qrCode,
    this.mqtt,
    this.isPro,
  });

  TokenResponseLogin.fromJson(Map<String, dynamic> json) {
    accessToken = json["accessToken"];
    refreshToken = json["refreshToken"];
    alreadyLoginBefore = json["alreadyLoginBefore"];
    firstName = json["firstName"];
    lastName = json["lastName"];
    firebaseId = json["firebaseId"];
    registrationLevel = json["registrationLevel"];
    registrationLevelRequired = json["registrationLevelRequired"];
    waitForApproval = json["waitForApproval"];
    qrCode = json["qrCode"];
    isPro = json["isPro"];

    mqtt = json["mqtt"] == null
        ? null
        : TokenResponseLoginMqtt.fromJson(json["mqtt"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["accessToken"] = accessToken;
    _data["refreshToken"] = refreshToken;
    _data["alreadyLoginBefore"] = alreadyLoginBefore;
    _data["firstName"] = firstName;
    _data["lastName"] = lastName;
    _data["firebaseId"] = firebaseId;
    _data["registrationLevel"] = registrationLevel;
    _data["registrationLevelRequired"] = registrationLevelRequired;
    _data["waitForApproval"] = waitForApproval;
    _data["qrCode"] = qrCode;
    _data["isPro"] = isPro;
    if (mqtt != null) {
      _data["mqtt"] = mqtt?.toJson();
    }
    return _data;
  }

  TokenResponseLogin copyWith({
    String? accessToken,
    String? refreshToken,
    int? alreadyLoginBefore,
    String? firstName,
    String? lastName,
    String? firebaseId,
    int? registrationLevel,
    int? registrationLevelRequired,
    int? waitForApproval,
    String? qrCode,
    TokenResponseLoginMqtt? mqtt,
  }) =>
      TokenResponseLogin(
        accessToken: accessToken ?? this.accessToken,
        refreshToken: refreshToken ?? this.refreshToken,
        alreadyLoginBefore: alreadyLoginBefore ?? this.alreadyLoginBefore,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        firebaseId: firebaseId ?? this.firebaseId,
        registrationLevel: registrationLevel ?? this.registrationLevel,
        registrationLevelRequired:
            registrationLevelRequired ?? this.registrationLevelRequired,
        waitForApproval: waitForApproval ?? this.waitForApproval,
        qrCode: qrCode ?? this.qrCode,
        mqtt: mqtt ?? this.mqtt,
      );
}

class TokenResponseLoginMqtt {
  String? channel;
  String? clientId;
  String? username;
  String? password;

  TokenResponseLoginMqtt(
      {this.channel, this.clientId, this.username, this.password});

  TokenResponseLoginMqtt.fromJson(Map<String, dynamic> json) {
    channel = json["channel"];
    clientId = json["clientId"];
    username = json["username"];
    password = json["password"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["channel"] = channel;
    _data["clientId"] = clientId;
    _data["username"] = username;
    _data["password"] = password;
    return _data;
  }

  TokenResponseLoginMqtt copyWith({
    String? channel,
    String? clientId,
    String? username,
    String? password,
  }) =>
      TokenResponseLoginMqtt(
        channel: channel ?? this.channel,
        clientId: clientId ?? this.clientId,
        username: username ?? this.username,
        password: password ?? this.password,
      );
}
