import '../resources.dart';

class BillingInfoRepo {
  BillingInfoRepo._();

  static BillingInfoRepo? _instance;

  factory BillingInfoRepo([AppApi? api]) {
    _instance ??= BillingInfoRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<bool> updateBillingInfosFromProOrUser(cardId) async {
    NetworkResponse response =
        await _api.updateBillingInfosFromProOrUser(cardId);
    return response.data ?? false;
  }

  Future<bool> deleteBillingInfosFromProOrUser(cardId) async {
    NetworkResponse response =
        await _api.deleteBillingInfosFromProOrUser(cardId);
    return response.data ?? false;
  }

  Future<bool> setDefaultBillingInfos(cardId) async {
    NetworkResponse response = await _api.setDefaultBillingInfos(cardId);
    return response.data ?? false;
  }

  Future<List<PaymentBillingInfo>> getBillingInfosFromPro(params) async {
    NetworkResponse response = await _api.getBillingInfosFromPro(params);
    return response.data ?? [];
  }

  Future<List<PaymentBillingInfo>> getBillingInfosFromProOrUser(params) async {
    NetworkResponse response = await _api.getBillingInfosFromProOrUser(params);
    return response.data ?? [];
  }

  Future<PaymentBillingInfo?> addBillingInfosFromProOrUser(params) async {
    NetworkResponse response = await _api.addBillingInfosFromProOrUser(params);
    return response.data;
  }
}
