import '../resources.dart';

class TheMovieRepo {
  TheMovieRepo._();

  static TheMovieRepo? _instance;

  factory TheMovieRepo() {
    _instance ??= TheMovieRepo._();
    return _instance!;
  }

  final AppApiImp _api = AppApiImp();

  Future<TheMovieDetail?> themoviedbMovieDetail(id, params) async {
    NetworkResponse response = await _api.themoviedbMovieDetail(id, params);
    return response.data;
  }

  Future<TheMoviePersonDetail?> themoviedbPersonDetail(id, params) async {
    NetworkResponse response = await _api.themoviedbPersonDetail(id, params);
    return response.data;
  }

  Future<List<TheMovieReview>> themoviedbMovieReview(id, params) async {
    NetworkResponse response = await _api.themoviedbMovieReview(id, params);
    return response.data ?? [];
  }

  Future<List<TheMovieModel>> themoviedbSearchMulti(params) async {
    NetworkResponse response = await _api.themoviedbSearchMulti(params);
    return response.data ?? [];
  }

  Future<List<TheMoviePerson>> themoviedbSearchPerson(params) async {
    NetworkResponse response = await _api.themoviedbSearchPerson(params);
    return response.data ?? [];
  }

  Future<List<TheMovieKeyword>> themoviedbSearchKeyword(params) async {
    NetworkResponse response = await _api.themoviedbSearchKeyword(params);
    return response.data ?? [];
  }

  Future<List<TheMovieModel>> themoviedbSearchMovie(params) async {
    NetworkResponse response = await _api.themoviedbSearchMovie(params);
    return response.data ?? [];
  }

  Future<List<TheMovieModel>> themoviedbTrending(
      media_type, time_window, params) async {
    NetworkResponse response =
        await _api.themoviedbTrending(media_type, time_window, params);
    return response.data ?? [];
  }

  Future<TheMovieCredit?> themoviedbMovieDetailCredits(id, params) async {
    NetworkResponse response =
        await _api.themoviedbMovieDetailCredits(id, params);
    return response.data;
  }

  Future<TheMoviePersonCredit?> themoviedbPersonCredits(id, params) async {
    NetworkResponse response = await _api.themoviedbPersonCredits(id, params);
    return response.data;
  }

  Future<List<TheMovieModel>> themoviedbDiscoverMovie(params) async {
    NetworkResponse response = await _api.themoviedbDiscoverMovie(params);
    return response.data ?? [];
  }

  Future<List<TheMovieDetailGenres>> themoviedbGenres(params) async {
    NetworkResponse response = await _api.themoviedbGenres(params);
    return response.data ?? [];
  }

  Future<TheMovieImage?> themoviedbMovieDetailImages(id, params) async {
    NetworkResponse response =
        await _api.themoviedbMovieDetailImages(id, params);
    return response.data;
  }

  Future<TheMoviePersonImage?> themoviedbPersonDetailImages(id, params) async {
    NetworkResponse response =
        await _api.themoviedbPersonDetailImages(id, params);
    return response.data;
  }

  Future<List<TheMovieVideo>> themoviedbMovieDetailVideos(id, params) async {
    NetworkResponse response =
        await _api.themoviedbMovieDetailVideos(id, params);
    return response.data ?? [];
  }

  Future<List<TheMovieModel>> themoviedbMovieDetailSimilar(id, params) async {
    NetworkResponse response =
        await _api.themoviedbMovieDetailSimilar(id, params);
    return response.data ?? [];
  }

  Future<List<TheMovieLanguage>> themoviedbConfigLanguage(params) async {
    NetworkResponse response = await _api.themoviedbConfigLanguage(params);
    return response.data ?? [];
  }

  Future<List<TheMovieBookmark>> getMyBookmarks(params) async {
    NetworkResponse response = await _api.getMyBookmarks(params);
    return response.data ?? [];
  }

  Future<List<TheMovieCollection>> getMyMovieCollections(params) async {
    NetworkResponse response = await _api.getMyMovieCollections(params);
    return response.data ?? [];
  }

  Future<TheMovieCollection?> createMovieCollection(params) async {
    NetworkResponse response = await _api.createMovieCollection(params);
    return response.data;
  }

  Future<bool> updateMovieCollection(params) async {
    NetworkResponse response = await _api.updateMovieCollection(params);
    return response.data ?? false;
  }

  Future<TmmAddToArckipelResult> addMovieInArckipelDb(params) async {
    NetworkResponse response = await _api.addMovieInArckipelDb(params);
    return response.data;
  }

  Future<bool> addMovieBookmarksToCollection(params) async {
    NetworkResponse response = await _api.addMovieBookmarksToCollection(params);
    return response.data ?? false;
  }

  Future<bool> removeMovieFromCollection(params) async {
    NetworkResponse response = await _api.removeMovieFromCollection(params);
    return response.data ?? false;
  }

  Future<bool> updateMyMovieInfos(params) async {
    NetworkResponse response = await _api.updateMyMovieInfos(params);
    return response.data ?? false;
  }
}
