import 'package:_private_core/_private_core.dart'; 

import '../resources.dart';

class WhatNextRepo {
  WhatNextRepo._();

  static WhatNextRepo? _instance;

  factory WhatNextRepo([AppApi? api]) {
    _instance ??= WhatNextRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<WhatNextModel?> whatsNext(lat, lng) async {
    NetworkResponse response = await _api.whatsNext(
        {'lat': lat, 'lng': lng, 'languageCode': appPrefs.languageCode});
    return response.data;
  }

  Future<List<ReminderType>> getReminderTypes() async {
    NetworkResponse response = await _api.getReminderTypes();
    return response.data ?? [];
  }
}
